#!/usr/bin/perl -w
use strict;
use Socket;
# my $proto = Socket::IPPROTO_TCP(); # of exporteer expliciet
# defined(my $proto = getprotobyname("tcp") ||
#     die "Unknown protocol 'tcp'";
my $proto = 0;
socket(my $socket, PF_INET, SOCK_STREAM, $proto) || 
  die "could not create socket: $!";

my $addr = inet_aton("127.0.0.1");
my $bind = pack_sockaddr_in(1234, $addr);
bind($socket, $bind) || 
    die "Could not bind socket to 127.0.0.1:1234: $!";
listen($socket, 5) ||
    die "Could not listen on socket: $!";

while (1) {
    my $peer_packed = accept(my $accepted, $socket);
    if (!$peer_packed) {
        print STDERR "Error accepting connection: $!\n";
        next;
    }
    
    my ($peer_port, $peer_address) = 
        unpack_sockaddr_in($peer_packed);
    my $peer_ip = inet_ntoa($peer_address);
    print STDERR "Received a connection from $peer_ip:$peer_port\n";
    print $accepted "Hello $peer_ip:$peer_port\n";
    sleep 5;
    close $accepted;
}
